// ParameterizedDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Parameterized.h"
#include "ParameterizedDlg.h"

#include "UserMasterSet.h"
#include "PermissionsQry.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CParameterizedDlg dialog



CParameterizedDlg::CParameterizedDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CParameterizedDlg::IDD, pParent)
  , m_strUserID(_T(""))
  , m_strUserName(_T(""))
  , m_iStatus(0)
  , m_iUseWildcards(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CParameterizedDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_TREE1, m_treePermissions);
  DDX_Text(pDX, IDC_EDIT1, m_strUserID);
  DDX_Text(pDX, IDC_EDIT2, m_strUserName);
  DDX_Text(pDX, IDC_EDIT3, m_iStatus);
  DDX_Check(pDX, IDC_CHECK1, m_iUseWildcards);
}

BEGIN_MESSAGE_MAP(CParameterizedDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
  ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
  ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


// CParameterizedDlg message handlers

BOOL CParameterizedDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CParameterizedDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CParameterizedDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CParameterizedDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CParameterizedDlg::OnBnClickedButton1()
{
  CAboutDlg().DoModal();
}

void CParameterizedDlg::OnBnClickedOk()
{
 CUserMasterSet* pUserMasterSet = NULL;

 try
 {
  pUserMasterSet = new CUserMasterSet();
 }
 catch(CMemoryException* pe)
 {
  TRACE("CParameterizedDlg::OnOk - Memory "
   "Exception creating recordset\n");

  pUserMasterSet = NULL;

  pe->Delete();
 }
  
 if (pUserMasterSet)
 {
  UpdateData(TRUE);

  try
  {
    pUserMasterSet->m_strFilter.Format("sUserID %s ?",
      m_iUseWildcards == 0 ? "=" : "like");

   pUserMasterSet->m_sUserIDParam = m_strUserID;
   if (pUserMasterSet->Open())
   {
    if (!pUserMasterSet->IsEOF())
    {     
     m_strUserName = pUserMasterSet->m_sUserName;
     m_iStatus = pUserMasterSet->m_iStatus;

     ShowPermissions();
     UpdateData(FALSE);
    }
    else
    {
     CString str = m_strUserID + CString(" was not "
      "found");

     AfxMessageBox(str);
    }
    pUserMasterSet->Close();
   }
   delete pUserMasterSet;
  }
  catch(CDBException* pe)
  {
   if (pUserMasterSet->IsOpen())
   {
    pUserMasterSet->Close();
   }
   delete pUserMasterSet;

   TRACE("CParameterizedDlg::OnOk - Database "
    "Exception - %s\n", pe->m_strError);

   pe->Delete();
  }
 }
}

void CParameterizedDlg::ShowPermissions()
{
 m_treePermissions.SetRedraw(FALSE);
 m_treePermissions.DeleteAllItems();

 CPermissionsQry* pPermissionsQry = NULL;

 try
 {
  pPermissionsQry = new CPermissionsQry();
 }
 catch(CMemoryException* pe)
 {
  TRACE("CParameterizedDlg::OnOk - Memory Exception "
   "creating recordset\n");

  pPermissionsQry = NULL;

  pe->Delete();
 }

 if (pPermissionsQry)
 {
  try
  {
   pPermissionsQry->m_sUserIDParam = m_strUserID;
   if (pPermissionsQry->Open())
   {
    if (!pPermissionsQry->IsEOF())
    {   
     HTREEITEM hCompany;

     CString strPrevCompanyID;  
     while (!pPermissionsQry->IsEOF())
     {     
      CString strCompanyName(pPermissionsQry->m_sCompanyName);
      hCompany = m_treePermissions.InsertItem(strCompanyName);

      strPrevCompanyID = 
       pPermissionsQry->m_sCompanyID;

      while ((!pPermissionsQry->IsEOF())
      && (strPrevCompanyID == (CString)pPermissionsQry->m_sCompanyID))
      {
       ASSERT(hCompany);
       if (hCompany)
       {
        CString strSubsystemName(pPermissionsQry->m_sSubsystemName);
        m_treePermissions.InsertItem(strSubsystemName, hCompany);
       }

       pPermissionsQry->MoveNext();
      }
     }
    }
    else
    {
     CString str;
     str.Format("No permissions found for %s", m_strUserID);
     m_treePermissions.InsertItem(str);
     str = "Note that wildcards will not work with the parameterized query!";
     m_treePermissions.InsertItem(str);
    }

    pPermissionsQry->Close();
   }
   delete pPermissionsQry;
  }
  catch(CDBException* pe)
  {
   if (pPermissionsQry->IsOpen())
   {
    pPermissionsQry->Close();
   }
   delete pPermissionsQry;
   TRACE("CParameterizedDlg::OnOk - Database "
    "Exception "
    "- %s\n", pe->m_strError);
  }
 }

 ExpandAllBranches();
 m_treePermissions.SetRedraw(TRUE);
}

void CParameterizedDlg::ExpandAllBranches()
{
 HTREEITEM hRoot = NULL;
 HTREEITEM hItem;
 for (HTREEITEM hItem = m_treePermissions.GetRootItem();
   hItem != NULL;
   hItem = m_treePermissions.GetNextSiblingItem(hItem))
 {
  if (!hRoot) hRoot = hItem;
  ExpandBranch(hItem);
 }
 m_treePermissions.Select(hRoot, TVGN_FIRSTVISIBLE);
}

void CParameterizedDlg::ExpandBranch(HTREEITEM hItem, BOOL bExpand /* = TRUE */)
{
  if (m_treePermissions.ItemHasChildren(hItem))
  {
    m_treePermissions.Expand(hItem, 
      bExpand ? TVE_EXPAND : TVE_COLLAPSE);
    hItem = m_treePermissions.GetChildItem(hItem);
    do
    {
        ExpandBranch(hItem);
    } while ((hItem =
    m_treePermissions.GetNextSiblingItem(hItem)) != NULL);
  }
}
